import java.applet.*;
import java.awt.*;
import java.util.Hashtable;
import java.util.Enumeration;
import java.io.OutputStream;
import java.util.Properties;
import java.util.zip.GZIPOutputStream;
import java.net.Socket;

public class memspeed extends Applet implements Runnable {
	public static class Page {
		byte[] mem;
		Page next;
		public Page( int size, Page n ) {
			mem = new byte[size];
			next = n;
		}
	}
	public static class Page2 {
		short[] mem;
		Page2 next;
		public Page2( int size, Page2 n ) {
			mem = new short[size/2];
			next = n;
		}
	}
	public static class Page4 {
		int[] mem;
		Page4 next;
		public Page4( int size, Page4 n ) {
			mem = new int[size/4];
			next = n;
		}
	}
	
	public class ResultPlotCanvas extends Canvas {
		Result results;
		long minbps, maxbps;
		long minpages, maxpages;
		long avgbps;
		ResultPlotCanvas( Result resultsIn ) {
			results = resultsIn;
			maxbps = minbps = results.Bps;
			minpages = maxpages = results.pages;
			long sumbps = results.Bps, samples = 1;
			Result cur = results.next;
			while ( cur != null ) {
				sumbps += cur.Bps;
				samples++;
				if ( cur.Bps > maxbps ) {
					maxbps = cur.Bps;
				}
				if ( cur.Bps < minbps ) {
					minbps = cur.Bps;
				}
				if ( cur.pages > maxpages ) {
					maxpages = cur.pages;
				}
				if ( cur.pages < minpages ) {
					minpages = cur.pages;
				}
				cur = cur.next;
			}
			avgbps = sumbps / samples;
			if ( ta != null ) {
				ta.append( results.label + 
						   "\nmax Bps " + maxbps +
						   "\navg Bps " + avgbps +
						   "\nmin Bps " + minbps +
						   "\nmin working bytes " + (minpages * pageSize) +
						   "\nmax working bytes " + (maxpages * pageSize) + "\n" );
			}
		}
		public void paint( Graphics g ) {
			int w = getWidth();
			int h = getHeight();
			Result cur = results;
			long pagerange = maxpages - minpages;
			long bpsrange = maxbps - minbps;
			if ( bpsrange == 0 || pagerange == 0 ) {
				return;
			}
			while ( cur != null ) {
				g.setColor( Color.red );
				g.drawOval( (int)((w * (cur.pages - minpages)) / pagerange),
							(int)((h * (maxbps - cur.Bps)) / bpsrange),
							2, 2 );
				cur = cur.next;
			}
			g.setColor( Color.black );
			g.drawString( results.label, 5, 20 );
			g.drawString( "max Bps " + maxbps, 5, 40 );
			g.drawString( "avg Bps " + avgbps, 5, 60 );
			g.drawString( "min Bps " + minbps, 5, 80 );
			g.drawString( "min working bytes " + (minpages * pageSize), 5, 100 );
			g.drawString( "max working bytes " + (maxpages * pageSize), 5, 120 );
			g.setColor( Color.blue );
			int avgheight = (int)((h * (maxbps - avgbps)) / bpsrange);
			g.drawLine( 0, avgheight, w, avgheight );
		}
	}
	public class ResultPlotFrame extends Frame {
		ResultPlotCanvas it;
		ResultPlotFrame( Result resultsIn ) {
			setSize( 400, 300 );
			Rectangle r = getBounds();
			Insets in = getInsets();
			r.y += in.top;
			r.x += in.left;
			r.width -= in.left + in.right;
			r.height -= in.top + in.bottom;
			it = new ResultPlotCanvas( resultsIn );
			setLayout( null );
			add( it );
			it.setBounds( r );
			it.show();
			show();
		}
	}
	public class Result {
		String label;
		int repeat;
		int pages;
		long bytes;
		long msec;
		long Bps;
		Result next;
		
		public Result( String l, int r, int p, long b, long m, long bp, Result n ) {
			label = l;
			repeat = r;
			pages = p;
			bytes = b;
			msec = m;
			Bps = bp;
			next = n;
		}
		
		public Result reverseList() {
			Result nl = null;
			Result n;
			Result cur = this;
			while ( cur != null ) {
				n = cur.next;
				cur.next = nl;
				nl = cur;
				cur = n;
			}
			return nl;
		}
		
		public String toString() {
			return label + "\trepeat=" + repeat + "\tpages=" + (pages*pageSize) + "\tbytes=" + bytes + "\tusec=" + (msec * 1000) + "\tBps=" + Bps;
		}
	}
	
	int pageSize = 4096*4;
	Page root = null;
	Page2 root2 = null;
	Page4 root4 = null;
	int pages = 0;
	//Result results = null;
	Hashtable resultHash = new Hashtable();
	int maxPages = 512;
	int baseRepeat = 512;
	//int pageStep = 4;
	
	public void printAllResults() {
		Enumeration i = resultHash.elements();
		while ( i.hasMoreElements() ) {
			Result results = (Result)i.nextElement();
			//results = results.reverseList();
			while ( results != null ) {
				System.out.println( results );
				results = results.next;
			}
		}
	}
	
	public void printAllResults( java.io.Writer out ) throws java.io.IOException {
		Enumeration i = resultHash.elements();
		while ( i.hasMoreElements() ) {
			Result results = (Result)i.nextElement();
			//results = results.reverseList();
			while ( results != null ) {
				out.write( results.toString() );
				out.write( "\n" );
				results = results.next;
			}
		}
	}
	
	int dummy = 0;
	
	void newResult( String l, int r, int p, long b, long m, long bp ) {
		resultHash.put( l, new Result( l, r, p, b, m, bp, (Result)resultHash.get( l ) ) );
	}

	public void testReadSpeed1( int repeat ) {
		long start, end;
		long bytes = 0;
		Page p;
		start = System.currentTimeMillis();
		while ( repeat > 0 ) {
			p = root;
			repeat--;
			while ( p != null ) {
				int len, i;
				byte[] pb;
				pb = p.mem;
				bytes += (len = pageSize);
				for ( i = 0; i < len; i++ ) {
					dummy += pb[i];
				}
				p = p.next;
			}
		}
		end = System.currentTimeMillis();
		long Bps = bytes * 1000;
		if ( end - start == 0 ) { return; }
		Bps /= end - start;
		newResult( "read1", repeat, pages, bytes, end - start, Bps );
	}
	
	public void testWriteSpeed1( int repeat ) {
		long start, end;
		long bytes = 0;
		Page p;
		start = System.currentTimeMillis();
		while ( repeat > 0 ) {
			p = root;
			repeat--;
			while ( p != null ) {
				int len, i;
				byte[] pb;
				pb = p.mem;
				bytes += (len = pageSize);
				for ( i = 0; i < len; i++ ) {
					pb[i] = (byte)i;
				}
				p = p.next;
			}
		}
		end = System.currentTimeMillis();
		long Bps = bytes * 1000;
		if ( end - start == 0 ) { return; }
		Bps /= end - start;
		newResult( "write1", repeat, pages, bytes, end - start, Bps );
	}
	
	public void testReadSpeed2( int repeat ) {
		long start, end;
		long bytes = 0;
		Page2 p;
		start = System.currentTimeMillis();
		while ( repeat > 0 ) {
			p = root2;
			repeat--;
			while ( p != null ) {
				short[] pb;
				pb = p.mem;
				bytes += pb.length * 2;
				for ( int i = 0; i < pb.length; i++ ) {
					dummy += pb[i];
				}
				p = p.next;
			}
		}
		end = System.currentTimeMillis();
		long Bps = bytes * 1000;
		if ( end - start == 0 ) { return; }
		Bps /= end - start;
		newResult( "read2", repeat, pages, bytes, end - start, Bps );
	}
	
	public void testWriteSpeed2( int repeat ) {
		long start, end;
		long bytes = 0;
		Page2 p;
		start = System.currentTimeMillis();
		while ( repeat > 0 ) {
			p = root2;
			repeat--;
			while ( p != null ) {
				short[] pb;
				pb = p.mem;
				bytes += pb.length * 2;
				for ( int i = 0; i < pb.length; i++ ) {
					pb[i] = (short)i;
				}
				p = p.next;
			}
		}
		end = System.currentTimeMillis();
		long Bps = bytes * 1000;
		if ( end - start == 0 ) { return; }
		Bps /= end - start;
		newResult( "write2", repeat, pages, bytes, end - start, Bps );
	}
	
	public void testReadSpeed4() {
		long start, end;
		long bytes = 0;
		Page4 p;
		int repeat;
		do {
			repeat = baseRepeat / pages;
			start = System.currentTimeMillis();
			while ( repeat > 0 ) {
				p = root4;
				repeat--;
				while ( p != null ) {
					int[] pb;
					pb = p.mem;
					bytes += pb.length * 4;
					for ( int i = 0; i < pb.length; i++ ) {
						dummy += pb[i];
					}
					p = p.next;
				}
			}
			end = System.currentTimeMillis();
			if ( end - start < 10 ) {
				baseRepeat *= 2;
			}
		} while ( end - start < 10 );
		long Bps = bytes * 1000;
		Bps /= end - start;
		newResult( "read4", repeat, pages, bytes, end - start, Bps );
	}
	
	public void testWriteSpeed4() {
		long start, end;
		long bytes = 0;
		Page4 p;
		int repeat;
		do {
			repeat = baseRepeat / pages;
			start = System.currentTimeMillis();
			while ( repeat > 0 ) {
				p = root4;
				repeat--;
				while ( p != null ) {
					int[] pb;
					pb = p.mem;
					bytes += pb.length * 4;
					for ( int i = 0; i < pb.length; i++ ) {
						pb[i] = i;
					}
					p = p.next;
				}
			}
			end = System.currentTimeMillis();
			if ( end - start < 10 ) {
				baseRepeat *= 2;
			}
		} while ( end - start < 10 );
		long Bps = bytes * 1000;
		Bps /= end - start;
		newResult( "write4", repeat, pages, bytes, end - start, Bps );
	}

	public void testReadLatency4( int repeat ) {
		long start, end;
		long bytes = 0;
		Page4 p;
		bytes = pages * repeat;
		start = System.currentTimeMillis();
		while ( repeat > 0 ) {
			p = root4;
			repeat--;
			while ( p != null ) {
				dummy += p.mem[0];
				p = p.next;
			}
		}
		end = System.currentTimeMillis();
		if ( end - start == 0 ) { return; }
		long Bps = bytes * 1000;
		Bps /= end - start;
		newResult( "readL", repeat, pages, bytes, end - start, Bps );
	}

	public static double jogoMips() {
		long start, end;
		int i, len = 128000000;
		int repeat = 1, j;
		do {
			repeat *= 2;
			start = System.currentTimeMillis();
			for ( j = 0; j < repeat; j++ ) {
				for ( i = 0; i < len; i++ ) {
				}
			}
			end = System.currentTimeMillis();
		} while ( end - start < 500 );
		double djm = len*repeat;
		djm /= (end - start);
		djm /= 1000.0;
		return djm;
	}
	
	public void runTests() {
		int repeat;
		if ( false ) {
		while ( pages < maxPages ) {
			root = new Page( pageSize, root );
			pages++;
			repeat = baseRepeat / pages;
			testReadSpeed1( repeat );
			testWriteSpeed1( repeat );
		}
		pages = 0;
		root = null;
		System.gc();
		while ( pages < maxPages ) {
			root2 = new Page2( pageSize, root2 );
			pages++;
			repeat = baseRepeat / pages;
			testReadSpeed2( repeat );
			testWriteSpeed2( repeat );
		}
		
		}
		pages = 0;
		root2 = null;
		System.gc();
		while ( pages < maxPages ) {
			//for ( int i = 0; i < pageStep; i++ ) {
				root4 = new Page4( pageSize, root4 );
				pages++;
			//}
			//repeat = baseRepeat / pages;
			testReadSpeed4(  );
			testWriteSpeed4(  );
		}
	}
	
	public static void main(String[] argv){
		memspeed i = new memspeed();
		System.out.println("begin memory bandwidth benchmark");
		i.runTests();
		i.printAllResults();
		System.out.println("end   memory bandwidth benchmark");
	}
	
	TextArea ta = null;
	Thread t = null;
	public void run() {
		double jm = jogoMips();
		ta.append( "jogomips " + Double.toString(jm) + "\n" );
		runTests();
		java.io.StringWriter sw = new java.io.StringWriter( 4000 );
		if ( false ) {
			try {
				printAllResults( sw );
				ta.setText( sw.toString() );
			} catch ( java.io.IOException e ) {
				e.printStackTrace();
			}
			
		}
		for ( Enumeration i = resultHash.keys(); i.hasMoreElements();  ) {
			String tn = (String)i.nextElement();
			new ResultPlotFrame( (Result)resultHash.get( tn ) );
		}
		doLayout();
		//System.out.println( ta.getText() );
		try {
			String host = getDocumentBase().getHost();
			int port = 5345;
			try {
				int tp = Integer.parseInt( getParameter( "port" ) );
				port = tp;
			} catch ( Throwable e ) {}
			Socket s = new Socket( host, port );
			OutputStream os = s.getOutputStream();
			GZIPOutputStream gos = new GZIPOutputStream( os );
			gos.write( ta.getText().getBytes() );
			Properties p = System.getProperties();
			p.store( gos, null );
			gos.close();
			os.close();
		} catch ( Throwable e ) {
			e.printStackTrace();
		}
	}
	public void init(){
		setLayout( new FlowLayout() );
		ta = new TextArea( 24, 60 );
		add( ta );
		ta.show();
		ta.setText("Initted");
		doLayout();
	}
	public void start(){
		(t = new Thread( this )).start();
		ta.setText("Running...\n");
	}
	public void stop(){
	}
	public void destroy(){
		
	}
	String[][] pinfo = {
		{ "port","1-65535","port to report results on" }
	};
	public String[][] getParameterInfo() {
		return pinfo;
	}
}
