#!/usr/bin/perl -w
# things to do:
# 1:
#  gserial | memspeedtest.pl
# 2:
#  mkfifo /tmp/plotp
#  memspeedtest.pl -i /tmp/plotp &
#  gserial | tee /tmp/plotp
#
# either way, the script can handle multiple runs of the test program
$finame = "-";
$domakedir = 1;
while ( $arg = shift ) {
  if ( $arg eq "-i" ) {
    $finame = shift;
  } elsif ( $arg eq "-nomkdir" ) {
    $domakedir = 0;
  } elsif ( $arg eq "-mkdir" ) {
    $domakedir = 1;
  } else {
    print STDERR "bogus arg \"$arg\"\n";
    exit 1;
  }
}
open FIN, $finame or die "$!";
while ( $line = <FIN> ) {
  if ( $line =~ /begin memory bandwidth benchmark/ ) {
    %test = ();
    INTEST: while ( $line = <FIN> ) {
      if ( $line =~ /end   memory bandwidth benchmark/ ) {
	last INTEST;
      } else {
	($line) = $line =~ /([^\r\n]*)/;
	@a = split '\t', $line;
	$testname = shift @a;
	$ts = $test{$testname};
	if ( (! defined($ts)) || (! $ts) ) {
	  $ts = [];
	}
	push @{$ts}, [@a];
	$test{$testname} = $ts;
      }
    }
#    $now = localtime;
    @nowa = localtime;
    $nowt = sprintf "%04d%02d%02d_%02d%02d%02d", $nowa[5] + 1900, $nowa[4] + 1, $nowa[3], $nowa[2], $nowa[1], $nowa[0];
    print "\n\n$nowt\n";
    if ( $domakedir ) {
      mkdir $nowt;
      chdir $nowt;
    }
    open IHF, ">index.html";
    open GPF, ">gpc";
print GPF<<EOF;
set terminal png
set xlabel "total memory"
set ylabel "bytes per second"
EOF
print IHF<<EOF;
<html><head><title>Memory Bandwidth</title></head>
<body bgcolor="#ffffff" text="#000000">
<h1>Memory Bandwidth</h1>
<p>plotted on ${nowt}</p>
EOF
    TESTL: foreach $testname ( sort keys %test ) {
      $ts = $test{$testname};
      if ( (! @{$ts}) || ($#{$ts} <= 0) ) {
	next TESTL;
      }
      print "\t$testname\n";
print GPF<<EOF;
set output "${testname}.png"
set title "${testname}"
plot "-"
EOF
print IHF<<EOF;
<img src="${testname}.png"><br>
EOF
      foreach $testresult ( @{$ts} ) {
	($pages) = ${$testresult}[1] =~ /pages=(.*)/;
	($Bps) = ${$testresult}[4] =~ /Bps=(.*)/;
        print GPF "$pages\t$Bps\n";
      }
  print GPF "e\n\n";
    }
    close GPF;
    system "gnuplot gpc";
    if ( $domakedir ) {
      chdir "..";
      unlink "memspeedplot_current";
      symlink $nowt,"memspeedplot_current";
      print IHF "<hr>\n";
      foreach $o ( <????????_??????/index.html> , "memspeedplot_current" ) {
	print IHF "<a href=\"../$o\">$o</a>\n";
      }
    }
print IHF<<EOF;
</body></html>
EOF
    close IHF;
  }
}
